import express from 'express';
import { Service, Container, Token, Inject } from 'typedi';
import { IPlugin, IPluginFactory, PluginOrderEnum } from "./core/plugin/pluginType";
import { RestController, GetMapping, PostMapping, DeleteMapping, UpdateMapping, PatchMapping, RequestQuery, RequestBody, RequestPathVariable, Request, Response, setExpressApp } from "./plugins/api/rest";
import { BizError } from "./plugins/api/type";
import { ProcessSingle } from "./core/env";
export { Service, Container, Token, Inject };
export { IPlugin, IPluginFactory, PluginOrderEnum };
export { RestController, GetMapping, PostMapping, DeleteMapping, UpdateMapping, PatchMapping, RequestQuery, RequestBody, RequestPathVariable, Request, Response, BizError };
export declare type HttpRequest = express.Request;
export declare type HttpResponse = express.Response;
export declare type Express = express.Express;
export declare const ___internal: {
    pluginRunner: {
        firstStage(app: express.Express): Promise<void>;
        beforeApiInit(app: express.Express): Promise<void>;
        apiInit(app: express.Express): Promise<void>;
        afterApiInit(app: express.Express): Promise<void>;
        lastStage(app: express.Express): Promise<void>;
    };
    setExpressApp: typeof setExpressApp;
    ExpressToken: Token<express.Express>;
    ProcessSingle: typeof ProcessSingle;
};
